[dispatch-core](../index.md) / [dispatch.core](./index.md)

## Package dispatch.core

### Types

| Name | Summary |
|---|---|
| [DefaultCoroutineScope](-default-coroutine-scope.md) | Marker interface which designates a [CoroutineScope](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) with a [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html) of `default`.`interface DefaultCoroutineScope : `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) |
| [DefaultDispatcherProvider](-default-dispatcher-provider/index.md) | Default implementation of [DispatcherProvider](-dispatcher-provider/index.md) which simply delegates to the corresponding properties in the [Dispatchers](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-dispatchers/index.html) singleton.`class DefaultDispatcherProvider : `[`DispatcherProvider`](-dispatcher-provider/index.md) |
| [DispatcherProvider](-dispatcher-provider/index.md) | Interface corresponding to the different [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html)'s offered by [Dispatchers](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-dispatchers/index.html).`interface DispatcherProvider : `[`Element`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/-element/index.html) |
| [IOCoroutineScope](-i-o-coroutine-scope.md) | Marker interface which designates a [CoroutineScope](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) with a [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html) of `io`.`interface IOCoroutineScope : `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) |
| [MainCoroutineScope](-main-coroutine-scope.md) | Marker interface which designates a [CoroutineScope](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) with a [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html) of `main`.`interface MainCoroutineScope : `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) |
| [MainImmediateCoroutineScope](-main-immediate-coroutine-scope.md) | Marker interface which designates a [CoroutineScope](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) with a [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html) of `mainImmediate`.`interface MainImmediateCoroutineScope : `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) |
| [UnconfinedCoroutineScope](-unconfined-coroutine-scope.md) | Marker interface which designates a [CoroutineScope](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) with a [CoroutineDispatcher](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-dispatcher/index.html) of `unconfined`.`interface UnconfinedCoroutineScope : `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html) |

### Extensions for External Classes

| Name | Summary |
|---|---|
| [kotlin.coroutines.CoroutineContext](kotlin.coroutines.-coroutine-context/index.md) |  |
| [kotlinx.coroutines.CoroutineScope](kotlinx.coroutines.-coroutine-scope/index.md) |  |
| [kotlinx.coroutines.flow.Flow](kotlinx.coroutines.flow.-flow/index.md) |  |

### Functions

| Name | Summary |
|---|---|
| [DefaultCoroutineScope](-default-coroutine-scope.md) | Factory function for a [DefaultCoroutineScope](-default-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `default` property of the `DispatcherProvider`.`fun DefaultCoroutineScope(job: `[`Job`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-job/index.html)` = SupervisorJob(), dispatcherProvider: `[`DispatcherProvider`](-dispatcher-provider/index.md)` = DefaultDispatcherProvider()): `[`DefaultCoroutineScope`](-default-coroutine-scope.md)<br>`fun DefaultCoroutineScope(coroutineContext: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)`): `[`DefaultCoroutineScope`](-default-coroutine-scope.md) |
| [DispatcherProvider](-dispatcher-provider.md) | Creates a default implementation of [DispatcherProvider](-dispatcher-provider/index.md).`fun DispatcherProvider(): `[`DispatcherProvider`](-dispatcher-provider/index.md) |
| [IOCoroutineScope](-i-o-coroutine-scope.md) | Factory function for an [IOCoroutineScope](-i-o-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `io` property of the `DispatcherProvider`.`fun IOCoroutineScope(job: `[`Job`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-job/index.html)` = SupervisorJob(), dispatcherProvider: `[`DispatcherProvider`](-dispatcher-provider/index.md)` = DefaultDispatcherProvider()): `[`IOCoroutineScope`](-i-o-coroutine-scope.md)<br>Factory function for a [IOCoroutineScope](-i-o-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `io` property of the `DispatcherProvider`.`fun IOCoroutineScope(coroutineContext: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)`): `[`IOCoroutineScope`](-i-o-coroutine-scope.md) |
| [MainCoroutineScope](-main-coroutine-scope.md) | Factory function for a [MainCoroutineScope](-main-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `main` property of the `DispatcherProvider`.`fun MainCoroutineScope(job: `[`Job`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-job/index.html)` = SupervisorJob(), dispatcherProvider: `[`DispatcherProvider`](-dispatcher-provider/index.md)` = DefaultDispatcherProvider()): `[`MainCoroutineScope`](-main-coroutine-scope.md)<br>`fun MainCoroutineScope(coroutineContext: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)`): `[`MainCoroutineScope`](-main-coroutine-scope.md) |
| [MainImmediateCoroutineScope](-main-immediate-coroutine-scope.md) | Factory function for a [MainImmediateCoroutineScope](-main-immediate-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `mainImmediate` property of the `DispatcherProvider`.`fun MainImmediateCoroutineScope(job: `[`Job`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-job/index.html)` = SupervisorJob(), dispatcherProvider: `[`DispatcherProvider`](-dispatcher-provider/index.md)` = DefaultDispatcherProvider()): `[`MainImmediateCoroutineScope`](-main-immediate-coroutine-scope.md)<br>`fun MainImmediateCoroutineScope(coroutineContext: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)`): `[`MainImmediateCoroutineScope`](-main-immediate-coroutine-scope.md) |
| [UnconfinedCoroutineScope](-unconfined-coroutine-scope.md) | Factory function for a [UnconfinedCoroutineScope](-unconfined-coroutine-scope.md) with a [DispatcherProvider](-dispatcher-provider/index.md). Dispatch defaults to the `unconfined` property of the `DispatcherProvider`.`fun UnconfinedCoroutineScope(job: `[`Job`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-job/index.html)` = SupervisorJob(), dispatcherProvider: `[`DispatcherProvider`](-dispatcher-provider/index.md)` = DefaultDispatcherProvider()): `[`UnconfinedCoroutineScope`](-unconfined-coroutine-scope.md)<br>`fun UnconfinedCoroutineScope(coroutineContext: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)`): `[`UnconfinedCoroutineScope`](-unconfined-coroutine-scope.md) |
| [withDefault](with-default.md) | Calls the specified suspending block with a given coroutine context, suspends until it completes, and returns the result.`suspend fun <T> withDefault(context: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)` = EmptyCoroutineContext, block: suspend `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html)`.() -> T): T` |
| [withIO](with-i-o.md) | Calls the specified suspending block with a given coroutine context, suspends until it completes, and returns the result.`suspend fun <T> withIO(context: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)` = EmptyCoroutineContext, block: suspend `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html)`.() -> T): T` |
| [withMain](with-main.md) | Calls the specified suspending block with a given coroutine context, suspends until it completes, and returns the result.`suspend fun <T> withMain(context: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)` = EmptyCoroutineContext, block: suspend `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html)`.() -> T): T` |
| [withMainImmediate](with-main-immediate.md) | Calls the specified suspending block with a given coroutine context, suspends until it completes, and returns the result.`suspend fun <T> withMainImmediate(context: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)` = EmptyCoroutineContext, block: suspend `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html)`.() -> T): T` |
| [withUnconfined](with-unconfined.md) | Calls the specified suspending block with a given coroutine context, suspends until it completes, and returns the result.`suspend fun <T> withUnconfined(context: `[`CoroutineContext`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.coroutines/-coroutine-context/index.html)` = EmptyCoroutineContext, block: suspend `[`CoroutineScope`](https://kotlin.github.io/kotlinx.coroutines/kotlinx-coroutines-core/kotlinx.coroutines/-coroutine-scope/index.html)`.() -> T): T` |
